#include <stdlib.h> 
#include <stdio.h> 

/* Reverses v[0..i] */
void flip(int v[], int i) 
{ 
    int tmp, esq = 0; 
    while (esq < i) 
    { 
        tmp = v[esq]; 
        v[esq] = v[i]; 
        v[i] = tmp; 
        esq++; 
        i--; 
    } 
} 

// Returns index of the maximum element in v[0..n-1]  
int findMax(int v[], int n) 
{ 
	int mi = 0; 
	for (int i = 0; i < n; i++) 
		if (v[i] > v[mi]) 
            mi = i; 
	return mi; 
} 

// The main function that sorts given array using flip operations 
int pancakeSort(int *v, int n) 
{  
    for (int curr_size = n; curr_size > 1; curr_size--) { 
        int mi = findMax(v, curr_size); // Find index of the maximum element in arr[0..curr_size-1] 
        
        if (mi != curr_size-1) //Move the maximum element to end of current array if it's not already at the end 
        { 
            flip(v, mi); //To move at the end, first move maximum number to beginning  
            flip(v, curr_size-1); // Now move the maximum number to end by reversing current array 
        } 
    } 
}  

// A utility function to print n array of size n  
void printArray(int v[], int n) 
{ 
    for (int i = 0; i < n; i++) 
        printf("%d ", v[i]); 
}

// Driver program to test above function 
int main() 
{ 
    int v[] = {23, 10, 20, 11, 12, 6, 7}; 
    int n = sizeof(v)/sizeof(v[0]); 
    pancakeSort(v, n); 
    puts("Sorted Array "); 
    printArray(v, n); 
    return 0; 
} 
